;==============================================================================
;       Test Department's WINDOWS 32 BIT x86 ASSEMBLY example's        017 
;==============================================================================

;==============================================================================
; ==> Part 017 : Progressbar class und Statusbar class
;------------------------------------------------------------------------------
; Hello all,
; this simple and small example demonstrates the Usage of the Progressbar class
; (msctls_progress32) and the Statusbar class (msctls_statusbar32).
; The CS_OWNDC style is used to register the window !
; Private DC's must not be deleted or released !
;
; 
; Test Department   td@crahkob.com

;==============================================================================
; Assembler directives
;------------------------------------------------------------------------------
.386                    ; specifies the processor our program want run on
.Model Flat ,StdCall    ; Flat for Win9x (32 Bit), Calling Convention
option casemap:none     ; case sensitive !

;==============================================================================
; Include all files where API functions resist you want use, set correct path
;------------------------------------------------------------------------------
include D:\Masm32\include\windows.inc
includelib kernel32.lib
includelib user32.lib
includelib gdi32.lib
includelib comdlg32.lib
includelib comctl32.lib

;==============================================================================
; Declaration of used API functions,take a look into WIN32.HLP and *.inc files
;------------------------------------------------------------------------------
GetModuleHandleA        PROTO :DWORD
InitCommonControls      PROTO
LoadIconA               PROTO :DWORD,:DWORD
CreateSolidBrush        PROTO :DWORD
LoadCursorA             PROTO :DWORD,:DWORD
RegisterClassExA        PROTO :DWORD
CreateWindowExA         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ShowWindow              PROTO :DWORD,:DWORD
InvalidateRect          PROTO :DWORD,:DWORD,:DWORD
UpdateWindow            PROTO :DWORD
GetMessageA             PROTO :DWORD,:DWORD,:DWORD,:DWORD
TranslateMessage        PROTO :DWORD
DispatchMessageA        PROTO :DWORD
PostQuitMessage         PROTO :DWORD
DefWindowProcA          PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExitProcess             PROTO :DWORD
DestroyWindow           PROTO :DWORD
SendMessageA            PROTO :DWORD,:DWORD,:DWORD,:DWORD
GetDC                   PROTO :DWORD
SetPixel                PROTO :DWORD,:DWORD,:DWORD,:DWORD
CreateCompatibleDC      PROTO :DWORD
CreateCompatibleBitmap  PROTO :DWORD,:DWORD,:DWORD
SelectObject            PROTO :DWORD,:DWORD
DeleteObject            PROTO :DWORD
DeleteDC                PROTO :DWORD
BitBlt                  PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD
GetSystemMetrics        PROTO :DWORD
FillRect                PROTO :DWORD,:DWORD,:DWORD
GetClientRect           PROTO :DWORD,:DWORD
ChooseColorA            PROTO :DWORD
CreateThread            PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
SetThreadPriority       PROTO :DWORD,:DWORD
CloseHandle             PROTO :DWORD
ExitThread              PROTO :DWORD

;==============================================================================
; .const    = the constants area starts here, constants are defined and fixed
;------------------------------------------------------------------------------
.const
; - Parameter MAIN WINDOW CallBack Procedure ( API=RegisterClassExA ) -
WP1_CallBack            equ [ebp+4]     ;return address
WP1_hWnd                equ [ebp+8]     ;handle of window who receives message
WP1_uMsg                equ [ebp+12]    ;the message number
WP1_wParam              equ [ebp+16]    ;extra info about the message
WP1_lParam              equ [ebp+20]    ;extra info about the message

;==============================================================================
; .Data     = the data area starts here, datas are defined but not fixed
;             MASM converts real4, real8, real10 values into FPU/IEEE standard.
;------------------------------------------------------------------------------
.Data
IconName                db "TDIcon",0               ;icon name in rc file
MenuName                db "TDMenu",0               ;menu name in rc file
Class                   db "TD_Progress",0          ;name of window class
WindowName              db "Test Department",0      ;window name
ProgressClassName       db "msctls_progress32",0    ;predefined ClassName
StatusClassName         db "msctls_statusbar32",0   ;predefined ClassName

align 4
Color                   dd 00000000h                ;choosen color
CCol                    dd 16 dup(00FFFFFFh)        ;default custom color

flag_thread             dd 0h                       ;flag thread active

;==============================================================================
; .Data?    = the data? area starts here, not defined and not fixed
;------------------------------------------------------------------------------
.data?
align 4
hWnd_main               dd ?            ;handle main window, copy for the thread

screen_width            dd ?            ;current screen width
screen_height           dd ?            ;current screen height

hWnd_Status             dd ?            ;handle status window
hWnd_Progress           dd ?            ;handle progress window

hDC                     dd ?            ;handle, main device context
hBitmap                 dd ?            ;handle, compatible bitmap
hCDC                    dd ?            ;handle, compatible device context
hObj_Old                dd ?            ;handle, old object

hThread                 dd ?            ;handle thread
ThreadID                dd ?            ;Thread ID

; - WndClassEx Structure ( API=RegisterClassExA ) -
cbSize                  dd ?            ;size in bytes of this structure
style                   dd ?            ;window style
lpfnWndProc             dd ?            ;address of user proc function
cbclsExtra              dd ?            ;extra bytes to allocate set to 0
cbWndExtra              dd ?            ;extra bytes class directive, rc file
hInstance               dd ?            ;program handle(API=GetModuleHandleA)
hIcon                   dd ?            ;handle of icon (API=LoadIconA)
hcursor                 dd ?            ;handle of cursor (API=LoadCursor)
hbrBackground           dd ?            ;background color, 0=transparent
lpszMenuName            dd ?            ;name of menu class in resource file
lpszClassName           dd ?            ;name of windows this window class
hIconSm                 dd ?            ;iconhandle 0=search in resource file
hdcDest                 dd ?            ;handle of dest. device context

; - Msg Structure ( API=GetMessageA ) - member POINT = POINT structure
hWnd                    dd ?            ;handle of window who receives message
message                 dd ?            ;the message number
wParam                  dd ?            ;extra info about the message
lParam                  dd ?            ;extra info about the message
time                    dd ?            ;time the message was posted
xpt                     dd ?            ;cursor x-position, POINT struc
ypt                     dd ?            ;cursor x-position, POINT struc

; - ChooseColorA Structure ( API=ChooseColorA ) -
cc_lStructSize          dd ?            ;the length in bytes of the structure
cc_hwndOwner            dd ?            ;
cc_hInstance            dd ?            ;
cc_rgbResult            dd ?            ;
cc_lpCustColors         dd ?            ;
cc_Flags                dd ?            ;
cc_lCustData            dd ?            ;
cc_lpfnHook             dd ?            ;
cc_lpTemplateName       dd ?            ;

; - RECT Structure (main window client area) -
rc_main_left            dd ?            ;RECT,x-coordinate upper-left corner
rc_main_top             dd ?            ;RECT,y-coordinate upper-left corner
rc_main_right           dd ?            ;RECT,x-coordinate lower-right corner
rc_main_bottom          dd ?            ;RECT,y-coordinate lower-right corner

; - RECT Structure (statusbar window client area) -
rc_status_left          dd ?            ;RECT,x-coordinate upper-left corner
rc_status_top           dd ?            ;RECT,y-coordinate upper-left corner
rc_status_right         dd ?            ;RECT,x-coordinate lower-right corner
rc_status_bottom        dd ?            ;RECT,y-coordinate lower-right corner

;==============================================================================
; .CODE     = our code area starts here     Main = label of our program code
;------------------------------------------------------------------------------
.Code
Main:

;==============================================================================
; Always get your program ID first (API=GetModuleHandleA)
;------------------------------------------------------------------------------
push    0h                          ;lpModuleHandle, 0=get program handle
call    GetModuleHandleA            ;- API Function -
mov     hInstance,eax               ;return value in eax=handle of program

;==============================================================================
; Progressbar class seems to be part of common controls, force to init...
;------------------------------------------------------------------------------
call    InitCommonControls          ;- API Function -

;==============================================================================
; The API function "RegisterClassExA" registers a window class.
; This API needs a "WNDCLASSEX" structure so we fill it with correct values.
;------------------------------------------------------------------------------
mov     cbSize,30h                  ;size in bytes of WNDCLASSEX structure
mov     style,23h                   ;window style,CS_OWNDC,CS_VREDRAW,CS_HREDRAW
mov     lpfnWndProc,OFFSET WP1      ;address of user lpfnWndProc function
mov     cbclsExtra,0h               ;extra bytes to allocate set to 0
mov     cbWndExtra,0h               ;class directive in rc file
mov     lpszMenuName,OFFSET MenuName;menu name in resource file,0=no menu
mov     lpszClassName,OFFSET Class  ;name of windows class
mov     hIconSm,0h                  ;iconhandle 0=search in rc file
;------------------------------------------------------------------------------
; API "CreateSolidBrush" creates a logical brush with the specified solid color
;------------------------------------------------------------------------------
push    00000000h                   ;crColor, brush color value RGB, black
call    CreateSolidBrush            ;- API Function -
mov     hbrBackground,eax           ;handle brush, background color
;------------------------------------------------------------------------------
; API "LoadIconA" loads an icon defined in the resource file and stores the
; handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    1000                        ;icon-string or icon resource id
push    hInstance                   ;our program handle
call    LoadIconA                   ;- API Function -
mov     hIcon,eax                   ;store handle of newly loaded icon
;------------------------------------------------------------------------------
; API "LoadCursorA" loads a default system cursor, in this case we must set
; hInstance to 0 and lpCursorName to a default system cursor value, here 32512
; Then we store the cursor handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    32512                       ;lpCursorName, default value in dezimal
push    0h                          ;hInstance, 0=default system cursor
call    LoadCursorA                 ;- API Function -
mov     hcursor,eax                 ;store handle of the cursor
;------------------------------------------------------------------------------
; Now, after filled the "WNDCLASSEX" structure we call API "RegisterClassEx"
;------------------------------------------------------------------------------
push    OFFSET cbSize               ;pointer to WNDCLASSEX structure
call    RegisterClassExA            ;- API Function -

;==============================================================================
; API "GetSystemMetrics" retrieves system metrics and system config settings
;------------------------------------------------------------------------------
push    0h                  ;nIndex, setting to retrieve, SM_CXSCREEN=0
call    GetSystemMetrics    ;- API Function -
mov     screen_width,eax    ;
push    1h                  ;nIndex, setting to retrieve, SM_CYSCREEN=1
call    GetSystemMetrics    ;- API Function -
mov     screen_height,eax   ;

;==============================================================================
; API "CreateWindowExA" creates an overlapped, pop-up, or child window with an
; extended style. The return value in EAX is the handle of the new window.
; This API sends a WM_CREATE message to the window procedure (WP1).
;------------------------------------------------------------------------------
push    0h                          ;lpParam, extra pointer data 0=no data
push    hInstance                   ;hInstance, handle of our program
push    0h                          ;hMenu, handle window menu 0=class menu
push    0h                          ;hWndParent, handle parent window 0=no
push    screen_height               ;intnHeight, window height pixel
push    screen_width                ;intnWidth, window width pixel
push    0h                          ;inty, vertical position window
push    0h                          ;intx, horizontal position window
push    02CA0000h                   ;dwStyle, look into WIN32.HLP
push    OFFSET WindowName           ;lpWindowName, pointer to window name
push    OFFSET Class                ;lpClassName, pointer to class name
push    0300h                       ;dwExStyle, extra window style 0=no
call    CreateWindowExA             ;- API Function -
mov     hWnd,eax                    ;hwnd,return value=handle of window

;==============================================================================
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    1h                          ;nCmdShow, show state 1=SW_SHOWNORMAL
push    hWnd                        ;hwnd, handle of window
call    ShowWindow                  ;- API Function -

;==============================================================================
; API "UpdateWindow" updates the area of the specified window by sending a
; WM_PAINT message to the window if the window's update region is not empty.
;------------------------------------------------------------------------------
push    hWnd                        ;hwnd, handle of window
call    UpdateWindow                ;- API Function -

LoopGetMessage:
;==============================================================================
; API "GetMessageA" retrieves a message + places it in the specified structure.
;------------------------------------------------------------------------------
push    0h                          ;wMsgFilterMax, highest message value
push    0h                          ;wMsgFilterMin, lowest message value
push    0h                          ;hWnd, handle of window who gets msg.
push    OFFSET hWnd                 ;lpMsg, pointer to MSG structure
call    GetMessageA                 ;- API Function -
cmp     eax,0h                      ;check if return value=0 (exit)
je      ExitPrg                     ;if return value is 0 goto LABEL

;==============================================================================
; API "TranslateMessage" translates virtual-key messages in character messages
;------------------------------------------------------------------------------
push    OFFSET hWnd                 ;lpMSG, pointer to msg structure
call    TranslateMessage            ;- API Function - keyboard code

;==============================================================================
; API "DispatchMessageA" function dispatches a message to a window procedure.
;------------------------------------------------------------------------------
push    OFFSET hWnd                 ;lpMSG, pointer to msg structure
call    DispatchMessageA            ;- API Function -
jmp     LoopGetMessage              ;check for message again, goto LABEL

ExitPrg:
;==============================================================================
; Next we terminate our program (API=ExitProcess)
;------------------------------------------------------------------------------
push    hInstance                   ;push our programm handle to exit
call    ExitProcess                 ;- API Function -

;##############################################################################
; The Window Procedure (API=RegisterClassExA) for this registered window.
;------------------------------------------------------------------------------
WP1:
push    ebp                         ;create stack frame
mov     ebp,esp                     ;
pushad                              ;push all register to the stack

mov     eax,WP1_uMsg                ;move the message number to eax
;==============================================================================
; WM_CREATE (value=01h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_01h:
cmp     eax,1h                      ;check if WM_CREATE message recieved
jne     WP1_uMsg_02h                ;if not goto LABEL
mov     eax,WP1_hWnd                ;copy main window handle for mmthread
mov     hWnd_main,eax
;------------------------------------------------------------------------------
; API "GetClientRect" retrieves the coordinates of a window's client area.
;------------------------------------------------------------------------------
push    OFFSET rc_main_left         ;lpRect, address struc. client coordinates
push    WP1_hWnd                    ;hwnd, handle of window
call    GetClientRect               ;- API Function -
;------------------------------------------------------------------------------
; API "GetDC" retrieves a handle of a display device context (DC) for the
; client area of the specified window.
;------------------------------------------------------------------------------
push    WP1_hWnd                    ;hwnd, handle of window
call    GetDC                       ;- API Function -
mov     hDC,eax                     ;handle of DC
;------------------------------------------------------------------------------
; API "CreateCompatibleBitmap" creates a bitmap compatible with the device that
; is associated with the specified device context.
;------------------------------------------------------------------------------
push    rc_main_bottom              ;nHeight, height of bitmap, in pixels
push    rc_main_right               ;nWidth, width of bitmap, in pixels
push    hDC                         ;hdc, handle of device context
call    CreateCompatibleBitmap      ;- API Function -
mov     hBitmap,eax                 ;handle of bitmap
;------------------------------------------------------------------------------
; API "CreateCompatibleDC" creates a memory device context (DC) compatible with
; the specified device.
;------------------------------------------------------------------------------
push    hDC                         ;hdc, handle memory device context,0=screen
call    CreateCompatibleDC          ;- API Function -
mov     hCDC,eax                    ;handle, compatible DC
;------------------------------------------------------------------------------
; API "SelectObject" selects an object into the specified device context.
; The new object replaces the previous object of the same type.
;------------------------------------------------------------------------------
push    hBitmap                     ;hgdiobj, handle of object
push    hCDC                        ;hdc, handle of device context
call    SelectObject                ;- API Function -
mov     hObj_Old,eax                ;handle of previously object
;------------------------------------------------------------------------------
; API "FillRect" fills a rectangle using the specified brush. Includes the left
; and top borders, but excludes the right and bottom borders of the rectangle.
;------------------------------------------------------------------------------
push    hbrBackground               ;hbr, handle of brush
push    OFFSET rc_main_left         ;lprc, address of structure with rectangle
push    hCDC                        ;hDC, handle of device context
call    FillRect                    ;- API Function -
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (STATUS).
;------------------------------------------------------------------------------
push    0h                          ;lpParam, extra pointer data 0=no data
push    hInstance                   ;hInstance, handle of our program
push    210h                        ;hMenu, the child-window ID
push    WP1_hWnd                    ;hWndParent, handle parent window 0=no
push    0Ch                         ;intnHeight, window height pixel
push    rc_main_right               ;intnWidth, window width pixel
mov     eax,rc_main_bottom          ;
sub     eax,0Ch                     ;
push    eax                         ;inty, vertical position window
push    0h                          ;intx, horizontal position window
push    54000000h                   ;dwStyle,
push    0h                          ;lpWindowName, pointer to window name
push    OFFSET StatusClassName      ;lpClassName, pointer to class name
push    0h                          ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA             ;- API Function -
mov     hWnd_Status,eax             ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "GetClientRect" retrieves the coordinates of a window's client area.
;------------------------------------------------------------------------------
push    OFFSET rc_status_left       ;lpRect, address struc. client coordinates
push    hWnd_Status                 ;hwnd, handle of window
call    GetClientRect               ;- API Function -
jmp     WP1_return

;==============================================================================
; WM_DESTROY (value=02h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_02h:
cmp     eax,2h                      ;check if value=2h (WM_DESTROY)
jne     WP1_uMsg_0Fh                ;if not 2h go to LABEL
cmp     flag_thread,1h              ;skip if thread is active
je      WP1_return                  ;
call    My_CleanSystem              ;- SubRoutine -
;------------------------------------------------------------------------------
; API "PostQuitMessage" indicates to Windows a request to terminate
;------------------------------------------------------------------------------
push    0h                          ;nExitCode, exit code=wParam
call    PostQuitMessage             ;- API Function -
popad                               ;pop all register back from stack
xor     eax,eax                     ;set eax to 0 to exit our program
mov     esp,ebp                     ;delete stack frame
pop     ebp                         ;
ret     10h                         ;return and clear stack

;==============================================================================
; WM_PAINT (value=0Fh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_0Fh:
cmp     eax,0Fh                     ;check if WM_PAINT message recieved
jne     WP1_uMsg_111h               ;if not goto label
;------------------------------------------------------------------------------
; API "BitBlt" performs a bit-block transfer of the color data corresponding
; to a rectangle of pixels from the specified source device context into a
; destination device context. 
;------------------------------------------------------------------------------
push    00CC0020h                   ;dwRop, raster operation code
push    0h                          ;nYSrc, y=src. rect. up-left corner
push    0h                          ;nXSrc, x=src. rect. up-left corner
push    hCDC                        ;hdcSrc, handle of source device
push    rc_main_bottom              ;nHeight, height of dest. rect.
push    rc_main_right               ;nWidth, width of dest. rect.
push    0h                          ;nYDest, y=dest. rect. up-left corner
push    0h                          ;nXDest, x=dest. rect. up-left corner
push    hDC                         ;hdcDest, handle destination device
call    BitBlt                      ;- API Function -
jmp     WP1_return

;==============================================================================
; WM_COMMAND (value=111h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_111h:
cmp     eax,111h                    ;check if WM_COMMAND message recieved
jne     WP1_uMsg_112h               ;if not goto label
mov     eax,WP1_wParam              ;extra info about the message in ax
cmp     ax,1h                       ;"Start" clicked ?
jne     WP1_return                  ;
cmp     flag_thread,1h              ;skip if thread is active
je      WP1_return                  ;
;------------------------------------------------------------------------------
; API "ChooseColor" creates a system-defined dialog box to select a color
;------------------------------------------------------------------------------
mov     cc_lStructSize,36           ;
mov     eax,WP1_hWnd                ;
mov     cc_hwndOwner,eax            ;
mov     eax,hInstance               ;
mov     cc_hInstance,eax            ;
mov     cc_rgbResult,0              ;
mov     cc_lpCustColors,OFFSET CCol ;default custom color table
mov     cc_Flags,103h               ;CC_RGBINIT=1, CC_FULLOPEN=2, CC_ANYCOLOR=100h
mov     cc_lCustData,0h             ;
mov     cc_lpfnHook,0h              ;
mov     cc_lpTemplateName,0h        ;
push    OFFSET cc_lStructSize       ;lpcc, pointer to choosecolor structure
call    ChooseColorA                ;- API Function -
cmp     eax,0h                      ;
je      WP1_return                  ;
mov     eax,cc_rgbResult            ;choosen color
mov     Color,eax                   ;
;------------------------------------------------------------------------------
; API "CreateThread" creates a thread to execute
;------------------------------------------------------------------------------
push    OFFSET ThreadID             ;lpThreadId, address of returned thread id
push    0h                          ;dwCreationFlags, creation flags
push    WP1_hWnd                    ;lpParameter, argument for new thread
push    OFFSET My_Thread            ;lpStartAddress, address of thread function
push    0h                          ;dwStackSize, init thread stack size, in db
push    0h                          ;lpThreadAttributes, address security attr.
call    CreateThread                ;- API Function -
mov     hThread,eax                 ;thread handle
;------------------------------------------------------------------------------
; SetThreadPriority function sets the priority value for the specified thread.
;------------------------------------------------------------------------------
push    2h                              ;nPriority, THREAD_PRIORITY_HIGHEST=2h
push    hThread                         ;hThread, handle to the thread
call    SetThreadPriority               ;- API Function -
;------------------------------------------------------------------------------
; API "CloseHandle" closes an open object handle
;------------------------------------------------------------------------------
push    ThreadID                    ;hObject, handle of object to close
call    CloseHandle                 ;- API Function -
jmp     WP1_return

;==============================================================================
; WM_SYSCOMMAND (value=112h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_112h:
cmp     eax,112h                    ;check if WM_COMMAND message recieved
jne     WP1_return                  ;if not goto label
mov     eax,WP1_wParam              ;extra info about the message
cmp     eax,0F060h                  ;SC_CLOSE=0F060h received ?
jne     WP1_return                  ;
cmp     flag_thread,1h              ;skip if thread is active
je      WP1_return_0                ;
call    My_CleanSystem              ;- SubRoutine -
jmp     WP1_return

;==============================================================================
; API "DefWindowProcA" calls the window procedure to provide default processing
; for any window messages that an application does not process.
; This function ensures that every message is processed.
; It is called with the same parameters received by the window procedure.
;------------------------------------------------------------------------------
WP1_return:
popad                               ;pop all register from stack
push    WP1_lParam                  ;extra info about the message
push    WP1_wParam                  ;extra info about the message
push    WP1_uMsg                    ;the message number
push    WP1_hWnd                    ;handle of window who receives message
call    DefWindowProcA              ;- API Function -
mov     esp,ebp                     ;delete stack frame
pop     ebp                         ;
ret     10h                         ;return and clear stack

;==============================================================================
; Leaving the window procedure returning TRUE (1) or FALSE (0) in EAX.
;------------------------------------------------------------------------------
WP1_return_0:
popad                           ;pop all register from stack
mov     eax,0h                  ;set EAX to FALSE (0)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
WP1_return_1:
popad                           ;pop all register from stack
mov     eax,1h                  ;set EAX to TRUE (1)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
;##############################################################################

;##############################################################################
; My Threads resist here
;------------------------------------------------------------------------------
My_Thread:
;------------------------------------------------------------------------------
; Display the progressbar in a status window
;------------------------------------------------------------------------------
push    ebp                         ;create stack frame
mov     ebp,esp                     ;
pushad                              ;save all register
mov     flag_thread,1h              ;set flag
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined classname (PROGRESS)
;------------------------------------------------------------------------------
push    0h                          ;lpParam, extra pointer data 0=no data
push    hInstance                   ;hInstance, handle of our program
push    220h                        ;hMenu, the child-window ID
push    hWnd_Status                 ;hWndParent, handle parent window 0=no
push    0Ch                         ;intnHeight, window height pixel
mov     eax,rc_status_right         ;
sub     eax,10h                     ;
push    eax                         ;intnWidth, window width pixel
push    5h                          ;inty, vertical position window
push    8h                          ;intx, horizontal position window
push    54000000h                   ;dwStyle, 
push    0h                          ;lpWindowName, pointer to window name
push    OFFSET ProgressClassName    ;lpClassName, pointer to class name
push    0h                          ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA             ;- API Function -
mov     hWnd_Progress,eax           ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    00000000h                   ;lParam, COLORREF value, new background color 
push    0h                          ;wParam, set to 0
push    2001h                       ;uMsg, PBM_SETBKCOLOR=2001h,(CCM_FIRST=2000h)+1
push    hWnd_Progress               ;hwnd, handle of destination window
call    SendMessageA                ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    0000D6FFh                   ;lParam, COLORREF value, new bar color, 0BGR 
push    0h                          ;wParam, set to 0
push    0409h                       ;uMsg, PBM_SETBARCOLOR=409h,(WM_USER=400h)+9
push    hWnd_Progress               ;hwnd, handle of destination window
call    SendMessageA                ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     eax,rc_main_bottom          ;
shl     eax,16                      ;move it into high word
push    eax                         ;lParam, 
push    0h                          ;wParam, set to 0
push    401h                        ;uMsg, PBM_SETRANGE=0401h (WM_USER+1)
push    hWnd_Progress               ;hwnd, handle of destination window
call    SendMessageA                ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    0h                          ;lParam, set to 0 
push    1                           ;wParam, nStepInc
push    404h                        ;uMsg, PBM_SETSTEP=0404h (WM_USER+4)
push    hWnd_Progress               ;hwnd, handle of destination window
call    SendMessageA                ;- API Function -
mov     esi,0h                      ;X
mov     edi,0h                      ;Y
My_Thread_SetPixel:
;------------------------------------------------------------------------------
; API "SetPixel" sets the pixel at specified coordinates to a specified color.
;------------------------------------------------------------------------------
push    Color                       ;crColor, pixel color 
push    edi                         ;Y, y-coordinate of pixel
push    esi                         ;X, x-coordinate of pixel
push    hCDC                        ;hdc, handle of device context, BUFFER !
call    SetPixel                    ;- API Function -
;------------------------------------------------------------------------------
; API "SetPixel" sets the pixel at specified coordinates to specified color.
;------------------------------------------------------------------------------
push    Color                       ;crColor, pixel color, BGR ! not RGB
push    edi                         ;Y, y-coordinate of pixel
push    esi                         ;X, x-coordinate of pixel
push    hDC                         ;hdc, handle of device context, SCREEN !
call    SetPixel                    ;- API Function -
inc     esi                         ;
cmp     esi,rc_main_right           ;
jb      My_Thread_SetPixel          ;
mov     esi,0h                      ;
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    0h                          ;lParam, set to 0 
push    0h                          ;wParam, set to 0
push    405h                        ;uMsg, PBM_STEPIT=0405h (WM_USER+5)
push    hWnd_Progress               ;hwnd, handle of destination window
call    SendMessageA                ;- API Function -
inc     edi                         ;
cmp     edi,rc_main_bottom          ;
jb      My_Thread_SetPixel          ;
;------------------------------------------------------------------------------
; API "DestroyWindow" function destroys the given window
;------------------------------------------------------------------------------
push    hWnd_Progress               ;hwnd, handle of window to destroy
call    DestroyWindow               ;- API Function -
;------------------------------------------------------------------------------
My_InvalidateMain:                  ;invalidates main screen
;------------------------------------------------------------------------------
push    0h                          ;bErase, erase-background flag
push    0h                          ;lpRect, rect structure, 0h=client area
push    hWnd_main                   ;hWnd, handle window update region
call    InvalidateRect              ;- API Function -
mov     flag_thread,0h              ;clear flag
;------------------------------------------------------------------------------
; API "ExitThread" ends a thread
;------------------------------------------------------------------------------
push    0h                          ;dwExitCode, exit code for this thread
call    ExitThread                  ;- API Function -
popad                               ;restore all register
xor     eax,eax                     ;set EAX to 0
mov     esp,ebp                     ;delete stack frame
pop     ebp                         ;
ret     4h
;##############################################################################

;******************************************************************************
; My own subroutine(s) for a compacter code resist here ...
;------------------------------------------------------------------------------
My_CleanSystem:
;------------------------------------------------------------------------------
; API "SelectObject" selects an object into the specified device context
;------------------------------------------------------------------------------
push    hObj_Old                    ;hObject, handle of bitmap
push    hCDC                        ;hdc, id memory device (DC)=src.
call    SelectObject                ;- API Function -
;------------------------------------------------------------------------------
; API "DeleteObject" deletes a logical pen, brush, font, bitmap, region, or
; palette, freeing all system resources associated with the object.
;------------------------------------------------------------------------------
push    hBitmap                     ;hObject, handle compatible graphic object
call    DeleteObject                ;- API Function -
;------------------------------------------------------------------------------
; API "DeleteDC" deletes the specified device context (DC).
;------------------------------------------------------------------------------
push    hCDC                        ;hdc, handle of compatible device context
call    DeleteDC                    ;- API Function -
ret
;******************************************************************************

;==============================================================================
; end Main       = end of our program code
;------------------------------------------------------------------------------
end Main                            ;end of our program code, entry point

;==============================================================================
; To create the exe file use this commands with your Microsoft Assembler/Linker
;------------------------------------------------------------------------------
; ml.exe /c /coff td_win32asm_017.asm                           ;asm command
; rc.exe /v rsrc.rc                                             ;rc command
; cvtres.exe /machine:ix86 rsrc.res
; link.exe /subsystem:windows td_win32asm_017.obj rsrc.obj      ;link command
;==============================================================================