;==============================================================================
;	    Test Department's Windows 32 BIT x86 ASSEMBLY example         810
;==============================================================================

;==============================================================================
; ==> Part 810 : Coding special, playing with OpCodes
;------------------------------------------------------------------------------
; You need an OpCode reference and you must familiar with it ...
; I use this several years ago (also illegal OpCodes) but that's another story.
; This source is based on a x86 example from Extasy (extasy@netcourrier.com).
; To understand what is going on here read this commented source and take a
; look into the dis-assembled exe ( _disasm.txt ) !
; 
; Test Department   td@crahkob.com

;==============================================================================
; Assembler directives
;------------------------------------------------------------------------------
.386                    ; specifies the processor our program want run on
.Model Flat ,StdCall    ; always the same for Win95 (32 Bit)
option casemap:none     ; case sensitive !!!

;==============================================================================
; Include all files where API functins resist you want use, set correct path
;------------------------------------------------------------------------------
include D:\Masm32\include\windows.inc
includelib kernel32.lib
includelib user32.lib

;==============================================================================
; Declaration of used API functions,take a look into WIN32.HLP and *.inc files
;------------------------------------------------------------------------------
GetModuleHandleA    PROTO :DWORD
ExitProcess         PROTO :DWORD
MessageBoxA         PROTO :DWORD,:DWORD,:DWORD,:DWORD

;==============================================================================
; .Data		= the data area starts here, datas are defined but not fixed
;------------------------------------------------------------------------------
.Data
MB1Titel                db "Playing with OpCodes",0     ;message box name
MB1Text                 db "for programmers only ...",0 ;text

;==============================================================================
; .Data?	= the data? area starts here, not defined and not fixed
;------------------------------------------------------------------------------
.data?
hInstance               dd ?            ; program handle

;==============================================================================
; .CODE		=our code area starts here	Main=label of our program code
;------------------------------------------------------------------------------
.Code
Main:
;------------------------------------------------------------------------------
; Always get your program ID first (API=GetModuleHandleA)
;------------------------------------------------------------------------------
push    0h                  ;lpModuleHandle, 0=get program handle
call    GetModuleHandleA    ;- API Function -
mov     hInstance,eax       ;return value in eax=handle of program


;##############################################################################
;********************************* HERE WE GO *********************************
;------------------------------------------------------------------------------
nop                         ;for fun only
mov     eax,OFFSET My_Box   ;pointer to subroutine, displaying a message box
db      0EBh                ;EB=JMP, OpCode, jump short, relative, +-128 byte
                            ;the next byte is the distance jumping to.
                            ;00-7F, 0-127 forward  in byte(s)
                            ;80-FF, 128-1 backward in byte(s), FF=1 byte back
call    eax                 ;FF=CALL, OpCode, absolute indirect near call  r32
                            ;D0=register 32, D0=EAX
nop                         ;for fun only
nop
nop
nop
nop
nop
;------------------------------------------------------------------------------
;********************************* That's it **********************************
;##############################################################################


;------------------------------------------------------------------------------
; Next we terminate our program (API=ExitProcess)
;------------------------------------------------------------------------------
ExitPrg:
push    hInstance           ;push our programm handle to exit
call    ExitProcess         ;- API Function -


My_Box:
;******************************************************************************
; API "MessageBoxA" creates a message box.
;------------------------------------------------------------------------------
push    0h                  ;uType, style, 4=MB_OK Button
push    OFFSET MB1Titel     ;lpCaption,pointer to title text
push    OFFSET MB1Text      ;lpText,pointer to text message box
push    0h                  ;handle of owner window 0=no owner
call    MessageBoxA         ;- API Function -
ret
;******************************************************************************


;==============================================================================
; end Main	= end of our program code
;------------------------------------------------------------------------------
end Main                    ;end of our program code, entry point

;==============================================================================
; To create the exe file use this commands with your Microsoft Assembler/Linker
;------------------------------------------------------------------------------
; ml.exe /c /coff td_win32asm_810.asm                        ;asm command
; link.exe /subsystem:windows td_win32asm_810.obj            ;link command
;==============================================================================